/**
 * Utilities for using Promises. Should be stateless.
 *
 * @CLIENT_SERVER
 */"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports["default"] = 
{ 
  ///**
  // * Runs all given promises serially.
  // *
  // * TODO: This is a defective function. Since the promise instances are already created, by the time they reach this function they may have already run.
  // *
  // * @param {Function} Promise
  // * @param {Array<Promise>} promises
  // */
  //allSerial(Promise, promises) {
  //  var accumulator = [], i, promise;
  //  var ready = Promise.resolve(null);
  //  var createPromiseReturnFunc = function(promise) {
  //    return promise;
  //  };
  //
  //  for (i = 0; i < promises.length; i++) {
  //    promise = promises[i];
  //    ready = ready.then(
  //      createPromiseReturnFunc(promise)
  //    ).then(function(value) {
  //      accumulator.push(value);
  //    });
  //  }
  //
  //  return ready.then(function() { return accumulator; });
  //},

  /**
   * Runs all promises inside the array in parallel. Will reject if any of
   * the given promises rejects.
   *
   * NOTE: I know I can use Promise.all() - but preliminary investigation
   * seems to conclude that it runs promises serially? Correct me if I'm wrong.
   *
   * @param {Function} Promise
   * @param {Array<Promise>} promises
   * @returns {Promise}
   */
  allParallel: function allParallel(Promise, promises) {var _this = this;
    if (promises.length <= 0) return Promise.resolve(null);
    return new Promise(function (resolve, reject) {
      var i, doneCount = 0, result = [];
      var registerResult = function registerResult(index, value) {
        result[index] = value;
        doneCount++;
        if (doneCount >= promises.length) {
          resolve(result);}};


      for (i = 0; i < promises.length; i++) {
        promises[i].then(_this.createResolveFunc(i, registerResult))["catch"](reject);}});}, 




  /**
   * @param {number} index
   * @param {Function} resolver
   * @returns {Function}
   */
  createResolveFunc: function createResolveFunc(index, resolver) {
    return function (value) {
      resolver(index, value);};}, 



  /**
   * Logs and throws the given error. Useful for catching framework promise
   * errors, so that it bubbles to the user.
   *
   * @param {Error} error
   */
  throwError: function throwError(error) {
    if (console) {
      console.error ? console.error(error) : console.log(error, error.stack);}

    throw error;} };module.exports = exports["default"];
//# sourceMappingURL=PromiseUtil.js.map