'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x3, _x4, _x5) {var _again = true;_function: while (_again) {var object = _x3, property = _x4, receiver = _x5;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x3 = parent;_x4 = property;_x5 = receiver;_again = true;desc = parent = undefined;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _defineProperty(obj, key, value) {if (key in obj) {Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });} else {obj[key] = value;}return obj;}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _segmentLocalLocalSegment = require('../segment/local/LocalSegment');var _segmentLocalLocalSegment2 = _interopRequireDefault(_segmentLocalLocalSegment);var _segmentActionNameUtil = require(
'../segment/ActionNameUtil');var _segmentActionNameUtil2 = _interopRequireDefault(_segmentActionNameUtil);var _helper = require(
'../helper');var _QueryResultJs = require(
'../QueryResult.js');var _QueryResultJs2 = _interopRequireDefault(_QueryResultJs);var _reactAddonsUpdate = require(

'react-addons-update');var _reactAddonsUpdate2 = _interopRequireDefault(_reactAddonsUpdate);

var DEFAULT_FIELD = { 
  value: null, 
  touched: false, 
  errorMessages: [], 
  isEnabled: true, 
  isValidating: false };


/**
 * Schema of the data structure:
 *
 * <pre>
 *   {
 *     formId: {
 *       fields: Object<string, T>,
 *       isEnabled: boolean
 *     },
 *     ...
 *   }
 * </pre>
 *
 * Where T is:
 *
 * <pre>
 *   Field | Object<string, T> | Array<T>
 * </pre>
 *
 * Field is:
 *
 * <pre>
 *   {
 *     touched: boolean,
 *     errorMessages: Array<string>,
 *     isValidating: boolean,
 *     value: ?
 *   }
 * </pre>
 *
 * IMPORTANT NOTE: This segment assumes that you do not name your fields
 * 'touched', 'errorMessages', 'isValidating', or 'value'.
 * TODO: Perform a check in createField for field name?
 *
 * @CLIENT_SERVER
 */var 
FormSegment = (function (_LocalSegment) {_inherits(FormSegment, _LocalSegment);_createClass(FormSegment, null, [{ key: 'id', value: 
























    function id() {
      return 'form';} }, { key: 'extractValues', value: 


    function extractValues(fields) {
      var isArray = fields instanceof Array;
      var result = isArray ? [] : {};
      for (var currentKey in fields) {
        if (!fields.hasOwnProperty(currentKey)) continue;
        currentKey = isArray ? Number(currentKey) : currentKey;
        FormSegment.fetchValue(fields[currentKey], currentKey, result);}

      return result;}


    /**
     * TODO: Remove the need for PromiseImpl.
     *
     * @param {Object} config
     * @param {CookieJar} cookieJar
     * @param {Promise} PromiseImpl
     */ }]);
  function FormSegment(config, cookieJar, PromiseImpl) {var _this = this;_classCallCheck(this, FormSegment);
    _get(Object.getPrototypeOf(FormSegment.prototype), 'constructor', this).call(this, config, cookieJar, PromiseImpl);
    var id = FormSegment.id();
    this._queryIdCache = {};
    this._setValueActionType = _segmentActionNameUtil2['default'].generate(id, 'SET_VALUE');
    this._setValuesActionType = _segmentActionNameUtil2['default'].generate(id, 'SET_VALUES');
    this._clearFieldActionType = _segmentActionNameUtil2['default'].generate(id, 'CLEAR_FIELD');
    this._mergeFieldsActionType = _segmentActionNameUtil2['default'].generate(id, 'MERGE_FIELDS');
    this._setIsValidatingActionType = _segmentActionNameUtil2['default'].generate(id, 'SET_IS_VALIDATING');
    this._setErrorMessagesActionType = _segmentActionNameUtil2['default'].generate(id, 'SET_ERRORS');
    this._addErrorMessagesActionType = _segmentActionNameUtil2['default'].generate(id, 'ADD_ERRORS');
    this._setFormEnabledStateActionType = _segmentActionNameUtil2['default'].generate(id, 'SET_ENABLED_STATE');
    this._clearFormActionType = _segmentActionNameUtil2['default'].generate(id, 'CLEAR_FORM');
    this._clearErrorMessagesActionType = _segmentActionNameUtil2['default'].generate(id, 'CLEAR_ERROR_MESSAGES');

    this._addListItemActionType = _segmentActionNameUtil2['default'].generate(id, 'ADD_ITEM');
    this._addListItemWithValueActionType = _segmentActionNameUtil2['default'].generate(id, 'ADD_ITEM_WITH_VALUE');
    this._removeListItemActionType = _segmentActionNameUtil2['default'].generate(id, 'REMOVE_ITEM');
    this._reorderListItemActionType = _segmentActionNameUtil2['default'].generate(id, 'REORDER_ITEM');
    this._reorderListItemIncActionType = _segmentActionNameUtil2['default'].generate(id, 'REORDER_ITEM_INC');
    this._reorderListItemDecActionType = _segmentActionNameUtil2['default'].generate(id, 'REORDER_ITEM_DEC');

    this._pieceCustomEqualComparators = { 
      errorMessages: function errorMessages(a, b) {
        return a.length == 0 && b.length == 0;} };



    this._actionCreator = { 
      // Simple field related actions.
      setFormEnabledState: function setFormEnabledState(formId, isEnabled) {
        return { 
          type: _this._setFormEnabledStateActionType, 
          formId: formId, 
          isEnabled: isEnabled };}, 


      setIsValidating: function setIsValidating(formId, map) {
        return { 
          type: _this._setIsValidatingActionType, 
          formId: formId, 
          map: map };}, 


      mergeFields: function mergeFields(formId, fields) {
        return { 
          type: _this._mergeFieldsActionType, 
          formId: formId, 
          fields: fields };}, 


      setValue: function setValue(formId, fieldName, value) {
        return { 
          type: _this._setValueActionType, 
          formId: formId, 
          fieldName: fieldName, 
          value: value };}, 


      setValues: function setValues(formId, values) {
        return { 
          type: _this._setValuesActionType, 
          formId: formId, 
          values: values };}, 


      clearField: function clearField(formId, fieldName) {
        return { 
          type: _this._clearFieldActionType, 
          formId: formId, 
          fieldName: fieldName };}, 


      setErrorMessages: function setErrorMessages(formId, fieldName, errorMessages) {
        return { 
          type: _this._setErrorMessagesActionType, 
          formId: formId, 
          fieldName: fieldName, 
          errorMessages: errorMessages };}, 


      addErrorMessages: function addErrorMessages(formId, messages) {
        return { 
          type: _this._addErrorMessagesActionType, 
          formId: formId, 
          messages: messages };}, 


      clearErrorMessages: function clearErrorMessages(formId, fieldNames) {
        return { 
          type: _this._clearErrorMessagesActionType, 
          formId: formId, 
          fieldNames: fieldNames };}, 


      clear: function clear(formId) {
        return { 
          type: _this._clearFormActionType, 
          formId: formId };}, 



      // Repeatable field related action.
      addListItem: function addListItem(formId, fieldName, minLength, maxLength) {
        return { 
          type: _this._addListItemActionType, 
          formId: formId, 
          fieldName: fieldName, 
          minLength: minLength, 
          maxLength: maxLength };}, 


      // Repeatable field related action.
      addListItemWithValue: function addListItemWithValue(formId, fieldName, values) {
        return { 
          type: _this._addListItemWithValueActionType, 
          formId: formId, 
          fieldName: fieldName, 
          values: values };}, 


      removeListItem: function removeListItem(formId, fieldName, index) {
        return { 
          type: _this._removeListItemActionType, 
          formId: formId, 
          fieldName: fieldName, 
          index: index };}, 


      reorderListItemInc: function reorderListItemInc(formId, fieldName, index) {var amount = arguments.length <= 3 || arguments[3] === undefined ? 1 : arguments[3];
        return { 
          type: _this._reorderListItemIncActionType, 
          formId: formId, 
          fieldName: fieldName, 
          index: index, 
          amount: amount };}, 


      reorderListItemDec: function reorderListItemDec(formId, fieldName, index) {var amount = arguments.length <= 3 || arguments[3] === undefined ? 1 : arguments[3];
        return { 
          type: _this._reorderListItemDecActionType, 
          formId: formId, 
          fieldName: fieldName, 
          index: index, 
          amount: amount };}, 


      reorderListItem: function reorderListItem(formId, fieldName, index, targetIndex) {
        return { 
          type: _this._reorderListItemActionType, 
          formId: formId, 
          fieldName: fieldName, 
          index: index, 
          targetIndex: targetIndex };} };}_createClass(FormSegment, [{ key: '_generateQueryId', value: 






    function _generateQueryId(query) {
      if (!query.hasOwnProperty('formId') || !query.hasOwnProperty('type')) {
        throw new Error('Query must contain formId and type properties.');}

      var queryId = query.formId + '-' + query.type;
      if (query.type[0] == 'f' && query.fieldName == null) {
        throw new Error('Field query should contain fieldName property.');}


      if (query.fieldName) {
        var stringifiedName = this._generateStringFieldName(query.fieldName);
        queryId += '-' + stringifiedName;}

      this._queryIdCache[queryId] = query;
      return queryId;}


    /**
     * @param {Array<string|number>|string} fieldName
     */ }, { key: '_generateStringFieldName', value: 
    function _generateStringFieldName(fieldName) {
      // This should join all members if the field name is an array or leave it
      // untouched if it's a string.
      return fieldName.toString();}


    /**
     * Simple field queries:
     *
     * <pre>
     *   {formId: 'formId', type: 'isEnabled'} --> true if form is enabled, false otherwise.
     *   {formId: 'formId', type: '*'} --> get all values as map, but without the error messages.
     *   {formId: 'formId', type: '**'} --> get all values as map with error messages.
     *   {formId: 'formId', type: 'hasErrors'} --> returns true if has errors, false otherwise.
     *   {formId: 'formId', type: 'field', fieldName: 'fieldName'} --> get all values of field.
     * </pre>
     *
     * Repeatable specific queries:
     *
     * <pre>
     *   {formId: 'formId', type: 'length', fieldName: ['fieldName']}
     * </pre>
     */ }, { key: '_queryState', value: 
    function _queryState(query, queryId, segmentState) {
      if (segmentState == null) {
        return _QueryResultJs2['default'].loaded(null);}

      switch (query.type) {
        case '*':
          return _QueryResultJs2['default'].loaded(this._getAllValues(segmentState, query.formId));
          break;
        case '**':
          return _QueryResultJs2['default'].loaded(segmentState[query.formId] ? segmentState[query.formId] : {});
          break;
        case 'isEnabled':
          return _QueryResultJs2['default'].loaded(segmentState[query.formId] ? segmentState[query.formId].isEnabled : true);
          break;
        case 'hasErrors':
          return _QueryResultJs2['default'].loaded(this._hasErrors(segmentState, query.formId));
          break;
        case 'field':
          return _QueryResultJs2['default'].loaded(this._getField(segmentState, query.formId, query.fieldName));
          break;
        case 'length':
          return _QueryResultJs2['default'].loaded(this._getLength(segmentState, query.formId, query.fieldName, query.minLength));
          break;
        default:
          throw new Error('Unable to translate query: ' + queryId);
          break;}} }, { key: '_getAllValues', value: 



    function _getAllValues(state, formId) {
      var result = {}, currentKey;
      if (state[formId] == null || state[formId].fields == null) return result;
      var fields = state[formId].fields;
      for (currentKey in fields) {
        if (!fields.hasOwnProperty(currentKey)) continue;
        FormSegment.fetchValue(fields[currentKey], currentKey, result);}

      return result;}


    /**
     * Recursively fill the given container with only values.
     *
     * @param {Object|Array} field
     * @param {string|number} currentKey
     * @param {Object} container
     */ }, { key: '_getLength', 























    /**
     * @param {Object} state
     * @param {string} formId
     * @param {string|Array<string>} fieldName
     * @param {?number} minLength
     * @return {number}
     */value: 
    function _getLength(state, formId, fieldName, minLength) {
      minLength = minLength == null ? 0 : minLength;
      if (state[formId] == null || state[formId].fields == null) return minLength;
      if ((0, _helper.isStringDuckType)(fieldName)) {
        if (state[formId].fields[fieldName] == null) return minLength;
        return state[formId].fields[fieldName].length;}

      var i, ref = state[formId].fields;
      for (i = 0; i < fieldName.length; i++) {
        if (ref == null || !ref.hasOwnProperty(fieldName[i])) {
          // Field hasn't been initialized yet.
          return minLength;}

        ref = ref[fieldName[i]];}

      return ref.length;} }, { key: '_hasErrors', value: 


    function _hasErrors(state, formId) {
      if (state[formId] == null || state[formId].fields == null) return false;
      return this._fetchHasError(state[formId].fields);} }, { key: '_fetchHasError', value: 


    function _fetchHasError(fields) {
      var i;
      if ((0, _helper.isArray)(fields.errorMessages)) {
        return fields.errorMessages.length > 0;} else 
      if ((0, _helper.isArray)(fields)) {
        for (i = 0; i < fields.length; i++) {
          if (this._fetchHasError(fields[i])) return true;}} else 

      {
        for (i in fields) {
          if (!fields.hasOwnProperty(i)) continue;
          if (this._fetchHasError(fields[i])) return true;}}


      return false;} }, { key: '_getField', value: 


    function _getField(state, formId, fieldName) {
      if (state[formId] == null || state[formId].fields == null) {
        return null;}

      if ((0, _helper.isStringDuckType)(fieldName)) {
        return state[formId].fields[fieldName];}

      // If not string, we'll need to loop through the field name.
      var i, ref = state[formId].fields;
      for (i = 0; i < fieldName.length; i++) {
        if (ref == null) {
          // This might happen, since addListItem() will add null array entry.
          return null;}

        if (!ref.hasOwnProperty(fieldName[i])) return null;
        ref = ref[fieldName[i]];}

      return ref;} }, { key: '_getActionCreator', value: 


    function _getActionCreator() {
      return this._actionCreator;} }, { key: '_getReducer', value: 


    function _getReducer() {var _this2 = this;
      return function (state, action) {
        if (state == null) state = {};
        switch (action.type) {
          case _this2._setFormEnabledStateActionType:
            return _this2._setFormEnabledState(state, action);
            break;
          case _this2._setIsValidatingActionType:
            return _this2._setIsValidating(state, action);
            break;
          case _this2._setValueActionType:
            return _this2._setValue(state, action);
            break;
          case _this2._setValuesActionType:
            return _this2._setValues(state, action);
            break;
          case _this2._clearFieldActionType:
            return _this2._clearField(state, action);
          case _this2._setErrorMessagesActionType:
            return _this2._setErrorMessages(state, action);
            break;
          case _this2._addErrorMessagesActionType:
            return _this2._addErrorMessages(state, action);
            break;
          case _this2._mergeFieldsActionType:
            return _this2._mergeFields(state, action);
            break;
          case _this2._clearFormActionType:
            return _this2._clearForm(state, action);
            break;
          case _this2._clearErrorMessagesActionType:
            return _this2._clearErrorMessages(state, action);
            break;
          case _this2._addListItemActionType:
            return _this2._addListItem(state, action);
            break;
          case _this2._addListItemWithValueActionType:
            return _this2._addListItemWithValue(state, action);
            break;
          case _this2._removeListItemActionType:
            return _this2._removeListItem(state, action);
            break;
          case _this2._reorderListItemIncActionType:
            return _this2._reorderListItemInc(state, action);
            break;
          case _this2._reorderListItemDecActionType:
            return _this2._reorderListItemDec(state, action);
            break;
          case _this2._reorderListItemActionType:
            return _this2._reorderListItem(state, action);
            break;}

        return state;};} }, { key: '_setFormEnabledState', value: 



    function _setFormEnabledState(state, action) {
      state = this._ensureFormExistence(state, action);
      state = (0, _reactAddonsUpdate2['default'])(state, _defineProperty({}, 
      action.formId, { 
        isEnabled: { $set: action.isEnabled } }));


      return state;} }, { key: '_setIsValidating', value: 


    function _setIsValidating(state, action) {
      state = this._ensureFormExistence(state, action);
      var fieldName, updateObject, tempAction;
      for (fieldName in action.map) {
        if (!action.map.hasOwnProperty(fieldName)) continue;
        tempAction = { formId: action.formId, fieldName: fieldName };
        state = this._extractField(state, tempAction).state;
        updateObject = this._createFieldUpdateObject(tempAction, { 
          isValidating: { $set: action.map[fieldName] }, 
          touched: { $set: true } });

        state = (0, _reactAddonsUpdate2['default'])(state, updateObject);}

      return state;} }, { key: '_setValue', value: 


    function _setValue(state, action) {
      state = this._ensureFormExistence(state, action);
      var result = this._extractField(state, action);
      if (result.field != null && result.field.value === action.value) {
        // If we are setting the same value, no need to update the state.
        return state;}

      state = result.state;
      var updateObject = this._createFieldUpdateObject(action, { 
        $set: { 
          value: action.value, 
          touched: true, 
          errorMessages: [], 
          isValidating: false, 
          isEnabled: true } });


      return (0, _reactAddonsUpdate2['default'])(state, updateObject);} }, { key: '_setValues', value: 


    function _setValues(state, action) {
      state = this._ensureFormExistence(state, action);
      var i, value;
      for (i = 0; i < action.values.length; i++) {
        value = action.values[i];
        state = this._setValue(state, this._actionCreator.setValue(
        action.formId, value.fieldName, value.value));}


      return state;} }, { key: '_mergeFields', value: 


    function _mergeFields(state, action) {
      state = this._ensureFormExistence(state, action);
      var i, updateObject, tempAction = { formId: action.formId };
      for (i = 0; i < action.fields.length; i++) {
        tempAction.fieldName = action.fields[i].fieldName;
        state = this._extractField(state, tempAction).state;
        updateObject = this._createFieldUpdateObject(tempAction, { 
          $merge: action.fields[i].object });

        state = (0, _reactAddonsUpdate2['default'])(state, updateObject);}

      return state;} }, { key: '_setErrorMessages', value: 


    function _setErrorMessages(state, action) {
      state = this._ensureFormExistence(state, action);
      state = this._extractField(state, action).state;
      var updateObject = this._createFieldUpdateObject(action, { 
        errorMessages: { $set: action.errorMessages } });

      return (0, _reactAddonsUpdate2['default'])(state, updateObject);} }, { key: '_addErrorMessages', value: 


    function _addErrorMessages(state, action) {
      state = this._ensureFormExistence(state, action);
      var i, updateObject, tempAction = { formId: action.formId };
      for (i = 0; i < action.messages.length; i++) {
        tempAction.fieldName = action.messages[i].fieldName;
        state = this._extractField(state, tempAction).state;
        updateObject = this._createFieldUpdateObject(tempAction, { 
          errorMessages: { $push: action.messages[i].messages } });

        state = (0, _reactAddonsUpdate2['default'])(state, updateObject);}

      return state;} }, { key: '_clearForm', value: 


    function _clearForm(state, action) {
      return (0, _reactAddonsUpdate2['default'])(state, _defineProperty({}, 
      action.formId, { 
        $set: { 
          fields: {}, 
          isEnabled: true } }));} }, { key: '_clearErrorMessages', value: 





    function _clearErrorMessages(state, action) {
      state = this._ensureFormExistence(state, action);
      var i, fieldName, field, result, updateObject, 
      tempAction = { formId: action.formId };
      for (i = 0; i < action.fieldNames.length; i++) {
        fieldName = action.fieldNames[i];
        tempAction.fieldName = fieldName;
        result = this._extractField(state, tempAction);
        state = result.state;
        field = result.field;
        if (field != null && field.errorMessages.length > 0) {
          updateObject = this._createFieldUpdateObject(
          { formId: action.formId, fieldName: fieldName }, 
          { errorMessages: { $set: [] } });

          state = (0, _reactAddonsUpdate2['default'])(state, updateObject);}}


      return state;} }, { key: '_clearField', value: 


    function _clearField(state, action) {
      state = this._ensureFormExistence(state, action);
      var result = this._extractField(state, action);
      state = result.state;
      var updateObject = this._createFieldUpdateObject(action, { 
        $set: null });

      return (0, _reactAddonsUpdate2['default'])(state, updateObject);} }, { key: '_addListItemWithValue', value: 


    function _addListItemWithValue(state, action) {
      state = this._ensureFormExistence(state, action);
      var result = this._extractField(state, action, []);
      var fieldLength = result.field != null ? result.field.length : 0, fieldName = action.fieldName, value, i;
      var parentFieldName;
      if (fieldName instanceof Array) {
        parentFieldName = fieldName.concat(fieldLength);} else 
      {
        parentFieldName = [fieldName, fieldLength];}

      state = result.state;
      for (i = 0; i < action.values.length; i++) {
        value = action.values[i];
        state = this._setValue(state, this._actionCreator.setValue(
        action.formId, parentFieldName.concat(value.fieldName), value.value));}


      return state;} }, { key: '_addListItem', value: 


    function _addListItem(state, action) {
      state = this._ensureFormExistence(state, action);
      var result = this._extractField(state, action, []);
      var fieldLength = result.field != null ? result.field.length : 0, addition = [], i, 
      minLength = action.minLength == null ? 0 : action.minLength, 
      maxLength = action.maxLength != null ? action.maxLength : null;
      state = result.state;
      var numberToAdd = 1;
      if (fieldLength < minLength) {
        numberToAdd += minLength - fieldLength;}

      if (maxLength != null && fieldLength + numberToAdd > maxLength) {
        // If more than max length, do not change.
        return state;}

      for (i = 0; i < numberToAdd; i++) {
        addition.push(null);}

      var updateObject = this._createFieldUpdateObject(action, { 
        $push: addition });

      return (0, _reactAddonsUpdate2['default'])(state, updateObject);} }, { key: '_removeListItem', value: 


    function _removeListItem(state, action) {
      state = this._ensureFormExistence(state, action);
      state = this._extractField(state, action, []).state;
      var updateObject = this._createFieldUpdateObject(action, { 
        $splice: [[action.index, 1]] });

      return (0, _reactAddonsUpdate2['default'])(state, updateObject);} }, { key: '_reorderListItemInc', value: 


    function _reorderListItemInc(state, action) {
      return this._reorderListItem(state, this._actionCreator.reorderListItem(
      action.formId, action.fieldName, action.index, action.index + action.amount));} }, { key: '_reorderListItemDec', value: 



    function _reorderListItemDec(state, action) {
      return this._reorderListItem(state, this._actionCreator.reorderListItem(
      action.formId, action.fieldName, action.index, action.index - action.amount));} }, { key: '_reorderListItem', value: 



    function _reorderListItem(state, action) {
      if (action.targetIndex < 0) {
        // No need to do anything
        return state;}

      state = this._ensureFormExistence(state, action);
      var item, result = this._extractField(state, action, []);
      state = result.state;
      if (result.field == null || !(0, _helper.isArray)(result.field)) {
        // If the field is non-existent or of the wrong type, there's no need to
        // do anything, just return the initialized field state.
        return state;}

      item = result.field[action.index];

      // First remove the item that we want to reorder, then we add the item
      // we just removed to the target index.
      var updateObject = this._createFieldUpdateObject(action, { 
        $splice: [[action.index, 1], [action.targetIndex, 0, item]] });

      return (0, _reactAddonsUpdate2['default'])(state, updateObject);}


    /**
     * Ensures that the given form exists in the state. Returns the new state
     * object with the initialized form.
     *
     * @param {Object} state
     * @param {Object} action
     * @returns {Object}
     */ }, { key: '_ensureFormExistence', value: 
    function _ensureFormExistence(state, action) {
      var form = state[action.formId];
      if (form == null) {
        state = (0, _reactAddonsUpdate2['default'])(state, _defineProperty({}, action.formId, { $set: { 
            fields: {}, 
            isEnabled: true } }));}


      return state;}


    /**
     * Extract field from state, while also initializing the field. Returns the
     * newly initialized state and the extracted field (may be null).
     *
     * IMPORTANT NOTE: It is assumed that this method is only called for fields,
     * not arrays/objects containing fields.
     *
     * @param {Object} state
     * @param {Object} action
     * @param {Object|Array|?} defaultFinalValue
     * @returns {{state: state, field: ?Object}}
     */ }, { key: '_extractField', value: 
    function _extractField(state, action, defaultFinalValue) {
      defaultFinalValue = defaultFinalValue || DEFAULT_FIELD;
      var fieldName = action.fieldName, result = state[action.formId].fields;
      if ((0, _helper.isStringDuckType)(fieldName)) {
        // Field name is string, piece of cake.
        if (result[action.fieldName] == null) {
          state = (0, _reactAddonsUpdate2['default'])(state, _defineProperty({}, 
          action.formId, { 
            fields: _defineProperty({}, 
            action.fieldName, { 
              $set: defaultFinalValue }) }));}





        return { 
          state: state, 
          field: result[action.fieldName] };}



      // Field name is array, now we need to loop.
      var i, j, namePiece, finalPieceIdx = fieldName.length - 1;
      var updateObject = _defineProperty({}, action.formId, { fields: {} }), fieldExists = true;
      var updateObjectFields = updateObject[action.formId].fields, hasUpdated = false;
      var isNextFieldStr, isCurrentResultArray;
      for (i = 0; i < fieldName.length; i++) {
        namePiece = fieldName[i];
        // Field only exists if they are not null. This allows us to add item to
        // repeatable list by adding null entry. The length of the list increases,
        // prompting the repeatable component to render additional field set. We
        // don't need to know the structure of the item to be added. Next time
        // a value setting action is triggered, this method will initialize the
        // structure for us.
        fieldExists = fieldExists && result.hasOwnProperty(namePiece) && result[namePiece] != null;
        if (fieldExists) {
          // If name piece still exists, just continue looping.
          result = result[namePiece];

          // Do type checking to tell users that they are being inconsistent.
          if (i != finalPieceIdx) {
            isNextFieldStr = (0, _helper.isStringDuckType)(fieldName[i + 1]);
            isCurrentResultArray = (0, _helper.isArray)(result);
            // If next name is number, current object must be an array. If next
            // name is string, current object must be an map.
            if (isNextFieldStr === isCurrentResultArray) {
              var fieldNameStr = this._generateStringFieldName(fieldName);
              throw new Error('Inconsistency in field, some expected array, other expected map: \'' + fieldNameStr + '\'.');}}



          updateObjectFields[namePiece] = {};
          updateObjectFields = updateObjectFields[namePiece];
          continue;}


        // If name piece does not exist, we'll need to initialize default values.
        // This would be empty object/array or the default field value.
        if (!hasUpdated) {
          // If we haven't run update(), run it first to replace this state with
          // a new one.
          if (i == finalPieceIdx) {
            updateObjectFields[namePiece] = { $set: defaultFinalValue };} else 
          if ((0, _helper.isStringDuckType)(fieldName[i + 1])) {
            // The next name piece is a string, so this name piece is an object.
            updateObjectFields[namePiece] = { $set: {} };} else 
          {
            // The next name piece is an number, so this name piece is an array.
            updateObjectFields[namePiece] = { $set: [] };}

          state = (0, _reactAddonsUpdate2['default'])(state, updateObject);
          updateObjectFields[namePiece] = {};
          updateObjectFields = updateObjectFields[namePiece];
          hasUpdated = true;

          // Create a new result reference.
          result = state[action.formId].fields;
          for (j = 0; j <= i; j++) {
            result = result[fieldName[j]];}} else 

        {
          // If we have run update() once, we don't need to do it again.
          // We can assign values directly.
          if (i == finalPieceIdx) {
            result[namePiece] = defaultFinalValue;} else 
          if ((0, _helper.isStringDuckType)(fieldName[i + 1])) {
            result[namePiece] = {};} else 
          {
            result[namePiece] = [];}

          result = result[namePiece];}}


      return { 
        state: state, 
        field: fieldExists ? result : null };}



    /**
     * Accepts an action object and a react-addons-update object, creating a ready
     * to use object for the update() method.
     *
     * Example output:
     *
     * <pre>
     *   {
     *     formId: {
     *       fields: {
     *         a: {
     *           b: {
     *             3: {
     *               $set: {...}
     *             }
     *           }
     *         }
     *       }
     *     }
     *   }
     * </pre>
     *
     * @param {Object} action
     * @param {Object} updateObject
     * @returns {Object}
     */ }, { key: '_createFieldUpdateObject', value: 
    function _createFieldUpdateObject(action, updateObject) {
      var i, result = {}, ref = result, fieldName = action.fieldName;
      if ((0, _helper.isStringDuckType)(fieldName)) {
        return _defineProperty({}, action.formId, { fields: _defineProperty({}, fieldName, updateObject) });}

      var finalLength = fieldName.length - 1;
      for (i = 0; i < fieldName.length; i++) {
        if (i == finalLength) {
          ref[fieldName[i]] = updateObject;} else 
        {
          ref[fieldName[i]] = {};
          ref = ref[fieldName[i]];}}


      result = _defineProperty({}, action.formId, { fields: result });
      return result;} }], [{ key: 'fetchValue', value: function fetchValue(field, currentKey, container) {var key;if (field == null) {container[currentKey] = null;} else if ((0, _helper.isArray)(field)) {// Its an list of T.
        container[currentKey] = [];for (key = 0; key < field.length; key++) {FormSegment.fetchValue(field[key], key, container[currentKey]);}} else if ((0, _helper.isArray)(field.errorMessages)) {// It's a field object.
        container[currentKey] = field.value;} else {// It's an object of T.
        container[currentKey] = {};for (key in field) {if (!field.hasOwnProperty(key)) continue;FormSegment.fetchValue(field[key], key, container[currentKey]);}}} }]);return FormSegment;})(_segmentLocalLocalSegment2['default']);exports['default'] = FormSegment;module.exports = exports['default']; // Simple field related action.
// Repeatable field related action.
//# sourceMappingURL=FormSegment.js.map