'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;desc = parent = undefined;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _defineProperty(obj, key, value) {if (key in obj) {Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });} else {obj[key] = value;}return obj;}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _SegmentJs = require('../../Segment.js');var _SegmentJs2 = _interopRequireDefault(_SegmentJs);var _ActionNameUtilJs = require(
'../ActionNameUtil.js');var _ActionNameUtilJs2 = _interopRequireDefault(_ActionNameUtilJs);var _QueryResultJs = require(
'../../QueryResult.js');var _QueryResultJs2 = _interopRequireDefault(_QueryResultJs);var _reactAddonsUpdate = require(

'react-addons-update');var _reactAddonsUpdate2 = _interopRequireDefault(_reactAddonsUpdate);

/**
 * You can query LocalSegment by specifying keys separated by dots. Examples:
 * "key", "key.subKey", etc.
 *
 * @CLIENT_SERVER
 */var 
LocalSegment = (function (_Segment) {_inherits(LocalSegment, _Segment);

























  /**
   * @param {Object} config
   * @param {CookieJar} cookieJar
   * @param {Object} dependencyActionCreatorMap
   */
  function LocalSegment(config, cookieJar, dependencyActionCreatorMap) {_classCallCheck(this, LocalSegment);
    _get(Object.getPrototypeOf(LocalSegment.prototype), 'constructor', this).call(this, config, cookieJar, dependencyActionCreatorMap);

    // Since segment name is guaranteed never to clash by ReduxStore, we can
    // safely use segment name as action type.
    var id = this.constructor.id();
    this._initActionType = _ActionNameUtilJs2['default'].generate(id, 'INIT');
    this._cleanActionType = _ActionNameUtilJs2['default'].generate(id, 'CLEAN');
    this._updateActionType = _ActionNameUtilJs2['default'].generate(id, 'UPDATE');}


  /**
   * @returns {boolean}
   */_createClass(LocalSegment, [{ key: 'createInitialData', 




    /**
     * @returns {Object | Array | string | number | void}
     */value: 
    function createInitialData() {
      return {};}


    /**
     * @param {any} query
     * @return {string}
     */ }, { key: '_generateQueryId', value: 
    function _generateQueryId(query) {
      if (typeof query != 'string') {
        throw new Error('Local segment query must be string. Found: \'' + query + '\'.');}

      return query;}


    /**
     * No need for loading. This is local segment after all.
     *
     * @param {any} query
     * @param {string} queryId
     * @param {any} segmentState
     * @return {void | Load}
     */ }, { key: '_createLoadFromQuery', value: 
    function _createLoadFromQuery(query, queryId, segmentState) {
      return null;} }, { key: '_queryState', value: 


    function _queryState(query, queryId, segmentState) {
      if (segmentState == null) return _QueryResultJs2['default'].loaded(null);
      if (typeof segmentState == 'object' && typeof queryId == 'string' && queryId != '') {
        var i, segment = segmentState, splitQuery = queryId.split('.');
        for (i = 0; i < splitQuery.length; i++) {
          if (segment.hasOwnProperty(splitQuery[i])) {
            segment = segment[splitQuery[i]];} else 
          {
            return _QueryResultJs2['default'].loaded(null);}}


        return _QueryResultJs2['default'].loaded(segment);}

      return _QueryResultJs2['default'].loaded(segmentState);}


    /**
     * Creates default query result for the given queryId.
     *
     * @param {string} queryId
     * @returns {?}
     */ }, { key: '_createInitialQueriedData', value: 
    function _createInitialQueriedData(queryId) {
      return null;}


    /**
     * Returns a reducer function. Called only once by Store, on registration
     * of a new segment.
     *
     * Reducer is responsible for:
     * 1) Initializing default segment state.
     * 2) Handling changes to segment state.
     *
     * NOTE: We could easily convert this into reduce() method. However in the
     * spirit of redux, reducers should be stateless functions. Let state of
     * subscription, queries, etc. be handled by others. We're making it
     * much simpler this way, methinks.
     *
     * @return {Function}
     */ }, { key: '_getReducer', value: 
    function _getReducer() {var _this = this;
      var initActionType = this._initActionType;
      var cleanActionType = this._cleanActionType;
      var updateActionType = this._updateActionType;
      var initialData = this.createInitialData();
      return function (state, action) {
        if (state == null) return initialData;
        switch (action.type) {
          case initActionType:
            return (0, _reactAddonsUpdate2['default'])(state, _defineProperty({}, action.queryId, { $set: _this._createInitialQueriedData(action.queryId) }));
            break;
          case cleanActionType:
            // Since there are no concept of loading in local segment, init and
            // clean does the same thing, which is populating the segment with
            // initial data.
            return initialData;
            break;
          case updateActionType:
            // Update using react immutability helper.
            return (0, _reactAddonsUpdate2['default'])(state, action.commands);
            break;}

        return state;};}



    /**
     * Returns an object containing action functions. Unlike reducer,
     * ActionCreator can be stateful objects. This is allowed since ActionCreator
     * has to deal with caching and AJAX requests.
     *
     * @return {Object}
     */ }, { key: '_getActionCreator', value: 
    function _getActionCreator() {
      var updateActionType = this._updateActionType;
      return { 
        createUpdateAction: function createUpdateAction(commands) {
          return { 
            type: updateActionType, 
            commands: commands };} };} }], [{ key: 'shouldHydrate', value: function shouldHydrate() {return false;} }]);return LocalSegment;})(_SegmentJs2['default']);exports['default'] = LocalSegment;module.exports = exports['default']; /**
                                                                                                                                                                                                                                               * @type {Object}
                                                                                                                                                                                                                                               */ /**
                                                                                                                                                                                                                                                   * @type {CookieJar}
                                                                                                                                                                                                                                                   */ /**
                                                                                                                                                                                                                                                       * @type {string}
                                                                                                                                                                                                                                                       */ /**
                                                                                                                                                                                                                                                           * @type {string}
                                                                                                                                                                                                                                                           */ /**
                                                                                                                                                                                                                                                               * @type {string}
                                                                                                                                                                                                                                                               */
//# sourceMappingURL=LocalSegment.js.map