'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;desc = parent = undefined;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _SegmentJs = require('../../Segment.js');var _SegmentJs2 = _interopRequireDefault(_SegmentJs);var _ActionNameUtilJs = require(
'../ActionNameUtil.js');var _ActionNameUtilJs2 = _interopRequireDefault(_ActionNameUtilJs);var _QueryResultJs = require(
'../../QueryResult.js');var _QueryResultJs2 = _interopRequireDefault(_QueryResultJs);var _LoadJs = require(
'../../Load.js');var _LoadJs2 = _interopRequireDefault(_LoadJs);

/**
 * Organizes pieces inside its segment as simple key-value map. This means
 * segment piece granularity is limited to top-level values (you cannot
 * query a particular field, for instance).
 *
 * @CLIENT_SERVER
 */var 
MapSegment = (function (_Segment) {_inherits(MapSegment, _Segment);















  /**
   * @param {Object} config
   * @param {CookieJar} cookieJar
   * @param {Object} dependencyActionCreatorMap
   */
  function MapSegment(config, cookieJar, dependencyActionCreatorMap) {_classCallCheck(this, MapSegment);
    _get(Object.getPrototypeOf(MapSegment.prototype), 'constructor', this).call(this, config, cookieJar, dependencyActionCreatorMap);

    // Since segment name is guaranteed never to clash by ReduxStore, we can
    // safely use segment name as action type.
    var id = this.constructor.id();
    this._setActionType = _ActionNameUtilJs2['default'].generate(id, 'SET');
    this._actionCreator = {};}


  /**
   * Generates a unique string representing the given query. Same query must
   * generate identical strings. Query ID is used by ReduxStore and Segment
   * to recognize identical queries.
   *
   * ABSTRACT: To be overridden by child implementations.
   *
   * @param {any} query
   * @return {string}
   * @private
   */_createClass(MapSegment, [{ key: '_generateQueryId', value: 
    function _generateQueryId(query) {
      throw new Error('User must override this _generateQueryId method! Instance: ' + this + '.');}


    /**
     * @param {any} query
     * @param {string} queryId
     * @param {any} segmentState
     * @return {Object | Load}
     */ }, { key: '_createLoadFromQuery', value: 
    function _createLoadFromQuery(query, queryId, segmentState) {
      throw new Error('User must override _createLoadFromQuery method! Instance: ' + this + '.');}


    /**
     * Creates an action object with the given state payload.
     *
     * IMPORTANT NOTE: Please make sure that you return a *new* object, as redux
     * store states are supposed to be immutable.
     *
     * @param {string} queryId
     * @param {void | any} payload
     * @param {void | Array<any>} errors
     * @return {Object}
     */ }, { key: '_createSetResultAction', value: 
    function _createSetResultAction(queryId, payload, errors) {
      return { 
        type: this._setActionType, 
        queryId: queryId, 
        payload: { 
          data: payload, 
          updated: Date.now ? Date.now() : new Date().getTime(), 
          errors: errors, 
          loaded: errors ? false : true } };}




    /**
     * @return {Object}
     */ }, { key: '_getActionCreator', value: 
    function _getActionCreator() {
      return this._actionCreator;} }, { key: '_queryState', value: 


    function _queryState(query, queryId, segmentState) {
      if (segmentState == null) return _QueryResultJs2['default'].notLoaded();
      var piece = segmentState[queryId];
      if (piece == null) return _QueryResultJs2['default'].notLoaded();
      return _QueryResultJs2['default'].loaded(piece);}


    /**
     * @return {Function}
     */ }, { key: '_getReducer', value: 
    function _getReducer() {var _this = this;
      var setActionType = this._setActionType;
      return function (state, action) {
        // If state is undefined, return initial state.
        if (!state) state = {};
        var newState;
        switch (action.type) {
          case setActionType:
            // Replace the map entry with the new loaded one.
            newState = _this._createNewStateObj(state);
            newState[action.queryId] = action.payload;
            return newState;
            break;}

        return state;};}



    /**
     * Create a new object, redux store state is supposed to immutable!
     *
     * @param {Object} state
     * @return {Object}
     */ }, { key: '_createNewStateObj', value: 
    function _createNewStateObj(state) {
      var newState = {}, queryId;
      for (queryId in state) {
        if (!state.hasOwnProperty(queryId)) continue;
        newState[queryId] = state[queryId];}

      return newState;} }]);return MapSegment;})(_SegmentJs2['default']);exports['default'] = MapSegment;module.exports = exports['default']; /**
                                                                                                                                               * @type {Object}
                                                                                                                                               */ /**
                                                                                                                                                   * @type {string}
                                                                                                                                                   */ /**
                                                                                                                                                       * @type {CookieJar}
                                                                                                                                                       */
//# sourceMappingURL=MapSegment.js.map