/**
 * Generates component browser search page.
 *
 * @param {Object} components
 * @return {string}
 * @SERVER
 */"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports["default"] = 
generateSearchPage;function generateSearchPage(components) {
  var result = "import React from 'react';\nimport Page from 'soya/lib/page/Page';\nimport RenderResult from 'soya/lib/page/RenderResult';\nimport register from 'soya/lib/client/Register';\nimport ReactRenderer from 'soya/lib/page/react/ReactRenderer';\nimport ReduxStore from 'soya/lib/data/redux/ReduxStore.js';\n\nimport ListPageComponent from 'soya/lib/browser/ListPageComponent.js';\nvar componentMap = " + 







  JSON.stringify(components) + ";\n";


  var vendor, componentName, i = 0;
  for (vendor in components) {
    for (componentName in components[vendor]) {
      result += "\nimport Component" + 
      i + " from '../../" + components[vendor][componentName].thumbnail + "';";
      if (components[vendor][componentName].doc) {
        result += "\nimport Doc" + 
        i + " from '../../" + components[vendor][componentName].doc + "';\ncomponentMap[" + 
        JSON.stringify(vendor) + "][" + JSON.stringify(componentName) + "].doc = Doc" + i + ";";}

      result += "\ncomponentMap[" + 
      JSON.stringify(vendor) + "][" + JSON.stringify(componentName) + "].thumbnail = Component" + i + ";";
      i++;}}



  result += "\n\nclass CmptBrowserSearchPage extends Page {\n  static get pageName() {\n    return 'CmptBrowserSearchPage';\n  }\n  \n  static getStoreNamespace() {\n    return '__component__browser';\n  }\n  \n  // TODO: Major abstraction leakage, how come we can know that the user is using ReduxStore?\n  createStore(initialState) {\n    var reduxStore = new ReduxStore(Promise, initialState, this.config, this.cookieJar);\n    return reduxStore;\n  }\n  \n  render(httpRequest, routeArgs, store, callback) {\n    var reactRenderer = new ReactRenderer();\n    reactRenderer.head = '<title>Component Browser</title>';\n    reactRenderer.body = React.createElement(ListPageComponent, {\n      context: this.createContext(store),\n      router: this.router,\n      componentMap: componentMap\n    });\n    var renderResult = new RenderResult(reactRenderer);\n    callback(renderResult);\n  }\n}\n\nregister(CmptBrowserSearchPage);\nexport default CmptBrowserSearchPage;";
































  return result;}
;module.exports = exports["default"];
//# sourceMappingURL=generateListPage.js.map