'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;desc = parent = undefined;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _Node2 = require('./Node');var _Node3 = _interopRequireDefault(_Node2);var _EmptyPathNode = require(
'./EmptyPathNode');var _EmptyPathNode2 = _interopRequireDefault(_EmptyPathNode);

/**
 * @CLIENT-SERVER
 */var 
PathNode = (function (_Node) {_inherits(PathNode, _Node);_createClass(PathNode, null, [{ key: 'constructFromConfig', 














    /**
     * @param {Array<string>} argArray
     * @return {Array<Node>}
     */value: 
    function constructFromConfig(argArray) {
      if (argArray.length != 1) {
        throw new Error('Domain node only receives one argument! Got ' + argArray.length + '.');}

      return PathNode.createFromPath(argArray[0] + '');}


    /**
     * Create list of PathNode representing the given path.
     *
     * @param {string} path
     * @return {Array<PathNode>}
     */ }, { key: 'createFromPath', value: 
    function createFromPath(path) {
      var i, result = [], pathSegments = PathNode.toPathSegments(path);
      for (i = 0; i < pathSegments.length; i++) {
        result.push(new PathNode(pathSegments[i]));}

      if (result.length == 0) {
        // Path is empty, assume it's for home page.
        result.push(new _EmptyPathNode2['default']());}

      return result;}


    /**
     * Split path into array of segments.
     *
     * '/' --> []
     * '/foo/bar' --> ['foo', 'bar']
     * '/foo/bar/' --> ['foo', 'bar', '']
     *
     * @param {string} path
     * @return {Array<string>}
     */ }, { key: 'toPathSegments', value: 
    function toPathSegments(path) {
      var splitPath = path.split('/');

      // Slash prefix is not useful at routing, as it always exists.
      // Slash at the end, however, is necessary for routing, so we want to keep that.
      if (splitPath[0] == '') {
        splitPath = splitPath.slice(1);}


      return splitPath;}


    /**
     * @type {string}
     */ }, { key: 'order', /**
                            * @returns {number}
                            */get: function get() {return 30;} /**
                                                                * @returns {string}
                                                                */ }, { key: 'nodeName', get: function get() {return 'path';} }]); /**
                                                                                                                                    * @param {string} segment
                                                                                                                                    */function PathNode(segment) {_classCallCheck(this, PathNode);
    _get(Object.getPrototypeOf(PathNode.prototype), 'constructor', this).call(this);
    this._segment = segment;}


  /**
   * @param {RoutingData} routingData
   */_createClass(PathNode, [{ key: 'evaluate', value: 
    function evaluate(routingData) {
      if (routingData.isAllSegmentConsumed()) {
        // We are still expecting a path segment. If all path segment is already
        // consumed, it's not a match.
        return false;}


      var isMatch = false;
      var decodedCurrentSegment = decodeURIComponent(routingData.getCurrentSegment());
      if (this._segment[0] == ':') {
        // Match all, but set route args first.
        var varName = this._segment.substr(1);
        routingData.resultRouteArgs[varName] = decodedCurrentSegment;
        isMatch = true;} else 

      if (this._segment == decodedCurrentSegment) {
        // Else match it char by char.
        isMatch = true;}


      if (isMatch) {
        routingData.consumeSegment();
        return true;}

      return false;}


    /**
     * @param {ReverseRoutingData} reverseRoutingData
     */ }, { key: 'reverseEvaluate', value: 
    function reverseEvaluate(reverseRoutingData) {
      if (this._segment[0] == ':') {
        var varName = this._segment.substr(1);
        reverseRoutingData.pathSegments.push(encodeURIComponent(reverseRoutingData.routeArgs[varName]));
        return;}

      reverseRoutingData.pathSegments.push(encodeURIComponent(this._segment));}


    /**
     * @returns {boolean}
     */ }, { key: 'isConsumingSegmentOnMatch', value: 
    function isConsumingSegmentOnMatch() {
      return true;}


    /**
     * @param {Node} node
     * @returns {boolean}
     */ }, { key: 'equals', value: 
    function equals(node) {
      return node instanceof PathNode && node._segment == this._segment;} }]);return PathNode;})(_Node3['default']);exports['default'] = PathNode;module.exports = exports['default'];
//# sourceMappingURL=PathNode.js.map